package eu.mhsl.minecraft.pixelblocks.listeners;

import eu.mhsl.minecraft.pixelblocks.PixelBlockItem;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.CraftItemEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;

import java.util.Objects;
import java.util.UUID;

public class CraftPixelBlockListener implements Listener {
    @EventHandler
    public void onCraft(CraftItemEvent event) {
        ItemStack result = event.getInventory().getResult();
        if(result == null) return;
        ItemMeta itemMeta = result.getItemMeta();
        PersistentDataContainer dataContainer = itemMeta.getPersistentDataContainer();
        if(!dataContainer.has(PixelBlockItem.idProperty)) return;
        String currentId = dataContainer.get(PixelBlockItem.idProperty, PersistentDataType.STRING);
        Objects.requireNonNull(currentId);
        if(!UUID.fromString(currentId).equals(PixelBlockItem.emptyBlockUUID)) return;

        dataContainer.set(PixelBlockItem.idProperty, PersistentDataType.STRING, UUID.randomUUID().toString());
        result.setItemMeta(itemMeta);
    }
}
